#   column, type, nullability, length, default, database-local

my $gratuitous = {

'Groups' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'Name', 'varchar', 'NULL', '16', '', '',
    'Description', 'varchar', 'NULL', '64', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [ ['Name'] ],
  'index' => [  ],
},

'ACL' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'PrincipalId', 'integer', 'NULL', '', '', '',
    'PrincipalType', 'varchar', 'NULL', '25', '', '',
    'RightName', 'varchar', 'NULL', '25', '', '',
    'RightScope', 'varchar', 'NULL', '25', '', '',
    'RightAppliesTo', 'integer', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [  ],
  'index' => [  ],
},

'Watchers' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'Type', 'varchar', 'NULL', '16', '', '',
    'Scope', 'varchar', 'NULL', '16', '', '',
    'Value', 'integer', 'NULL', '', '', '',
    'Email', 'varchar', 'NULL', '255', '', '',
    'Quiet', 'integer', 'NULL', '', '', '',
    'Owner', 'integer', 'NULL', '', '', '',
    'Creator', 'integer', 'NULL', '', '', '',
    'Created', 'timestamp', 'NULL', '', '', '',
    'LastUpdatedBy', 'integer', 'NULL', '', '', '',
    'LastUpdated', 'timestamp', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [  ],
  'index' => [  ],
},

'Links' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'Base', 'varchar', 'NULL', '240', '', '',
    'Target', 'varchar', 'NULL', '240', '', '',
    'Type', 'varchar', '', '20', '', '',
    'LocalTarget', 'integer', 'NULL', '', '', '',
    'LocalBase', 'integer', 'NULL', '', '', '',
    'LastUpdatedBy', 'integer', 'NULL', '', '', '',
    'LastUpdated', 'timestamp', 'NULL', '', '', '',
    'Creator', 'integer', 'NULL', '', '', '',
    'Created', 'timestamp', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [ ['Base', 'Target', 'Type'] ],
  'index' => [  ],
},

'Users' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'UserId', 'varchar', '', '120', '', '',
    'Password', 'varchar', 'NULL', '40', '', '',
    'Comments', 'blob', 'NULL', '', '', '',
    'Signature', 'blob', 'NULL', '', '', '',
    'EmailAddress', 'varchar', 'NULL', '120', '', '',
    'FreeformContactInfo', 'blob', 'NULL', '', '', '',
    'Organization', 'varchar', 'NULL', '200', '', '',
    'Disabled', 'integer', 'NULL', '', '', '',
    'CanManipulate', 'integer', 'NULL', '', '', '',
    'RealName', 'varchar', 'NULL', '120', '', '',
    'Nickname', 'varchar', 'NULL', '16', '', '',
    'Lang', 'varchar', 'NULL', '16', '', '',
    'EmailEncoding', 'varchar', 'NULL', '16', '', '',
    'WebEncoding', 'varchar', 'NULL', '16', '', '',
    'ExternalContactInfoId', 'varchar', 'NULL', '100', '', '',
    'ContactInfoSystem', 'varchar', 'NULL', '30', '', '',
    'ExternalAuthId', 'varchar', 'NULL', '100', '', '',
    'AuthSystem', 'varchar', 'NULL', '30', '', '',
    'Gecos', 'varchar', 'NULL', '16', '', '',
    'HomePhone', 'varchar', 'NULL', '30', '', '',
    'WorkPhone', 'varchar', 'NULL', '30', '', '',
    'MobilePhone', 'varchar', 'NULL', '30', '', '',
    'PagerPhone', 'varchar', 'NULL', '30', '', '',
    'Address1', 'varchar', 'NULL', '200', '', '',
    'Address2', 'varchar', 'NULL', '200', '', '',
    'City', 'varchar', 'NULL', '100', '', '',
    'State', 'varchar', 'NULL', '100', '', '',
    'Zip', 'varchar', 'NULL', '16', '', '',
    'Country', 'varchar', 'NULL', '50', '', '',
    'Creator', 'integer', 'NULL', '', '', '',
    'Created', 'timestamp', 'NULL', '', '', '',
    'LastUpdatedBy', 'integer', 'NULL', '', '', '',
    'LastUpdated', 'timestamp', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [ ['UserId'] ],
  'index' => [  ],
},

'Scrips' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'Name', 'varchar', 'NULL', '255', '', '',
    'Description', 'varchar', 'NULL', '255', '', '',
    'Type', 'varchar', 'NULL', '60', '', '',
    'ExecModule', 'varchar', 'NULL', '60', '', '',
    'DefaultTemplate', 'integer', 'NULL', '', '', '',
    'Argument', 'varchar', 'NULL', '255', '', '',
    'Creator', 'integer', 'NULL', '', '', '',
    'Created', 'timestamp', 'NULL', '', '', '',
    'LastUpdatedBy', 'integer', 'NULL', '', '', '',
    'LastUpdated', 'timestamp', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [  ],
  'index' => [  ],
},

'Tickets' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'EffectiveId', 'integer', 'NULL', '', '', '',
    'Queue', 'integer', 'NULL', '', '', '',
    'Alias', 'varchar', 'NULL', '40', '', '',
    'Type', 'varchar', 'NULL', '16', '', '',
    'IssueStatement', 'integer', 'NULL', '', '', '',
    'Resolution', 'integer', 'NULL', '', '', '',
    'Owner', 'integer', 'NULL', '', '', '',
    'Subject', 'varchar', 'NULL', '200', '[no subject]', '',
    'InitialPriority', 'integer', 'NULL', '', '', '',
    'FinalPriority', 'integer', 'NULL', '', '', '',
    'Priority', 'integer', 'NULL', '', '', '',
    'Status', 'varchar', 'NULL', '10', '', '',
    'TimeWorked', 'integer', 'NULL', '', '', '',
    'TimeLeft', 'integer', 'NULL', '', '', '',
    'Told', 'timestamp', 'NULL', '', '', '',
    'Starts', 'timestamp', 'NULL', '', '', '',
    'Started', 'timestamp', 'NULL', '', '', '',
    'Due', 'timestamp', 'NULL', '', '', '',
    'Resolved', 'timestamp', 'NULL', '', '', '',
    'LastUpdatedBy', 'integer', 'NULL', '', '', '',
    'LastUpdated', 'timestamp', 'NULL', '', '', '',
    'Creator', 'integer', 'NULL', '', '', '',
    'Created', 'timestamp', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [ [ 'Alias']  ],
  'index' => [  ],
},

'GroupMembers' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'GroupId', 'integer', 'NULL', '', '', '',
    'UserId', 'integer', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [ ['GroupId', 'UserId']  ],
  'index' => [  ],
},

'Queues' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'QueueId', 'varchar', '', '40', '', '',
    'Description', 'varchar', 'NULL', '120', '', '',
    'CorrespondAddress', 'varchar', 'NULL', '40', '', '',
    'CommentAddress', 'varchar', 'NULL', '40', '', '',
    'InitialPriority', 'integer', 'NULL', '', '', '',
    'FinalPriority', 'integer', 'NULL', '', '', '',
    'DefaultDueIn', 'integer', 'NULL', '', '', '',
    'Creator', 'integer', 'NULL', '', '', '',
    'Created', 'timestamp', 'NULL', '', '', '',
    'LastUpdatedBy', 'integer', 'NULL', '', '', '',
    'LastUpdated', 'timestamp', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [ ['QueueId'] ],
  'index' => [  ],
},

'Transactions' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'EffectiveTicket', 'integer', 'NULL', '', '', '',
    'Ticket', 'integer', 'NULL', '', '', '',
    'TimeTaken', 'integer', 'NULL', '', '', '',
    'Type', 'varchar', 'NULL', '20', '', '',
    'Field', 'varchar', 'NULL', '40', '', '',
    'OldValue', 'varchar', 'NULL', '255', '', '',
    'NewValue', 'varchar', 'NULL', '255', '', '',
    'Data', 'varchar', 'NULL', '100', '', '',
    'Creator', 'integer', 'NULL', '', '', '',
    'Created', 'timestamp', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [  ],
  'index' => [  ],
},

'ScripScope' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'Scrip', 'integer', 'NULL', '', '', '',
    'Queue', 'integer', 'NULL', '', '', '',
    'Template', 'integer', 'NULL', '', '', '',
    'Creator', 'integer', 'NULL', '', '', '',
    'Created', 'timestamp', 'NULL', '', '', '',
    'LastUpdatedBy', 'integer', 'NULL', '', '', '',
    'LastUpdated', 'timestamp', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [  ],
  'index' => [  ],
},

'Attachments' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'TransactionId', 'integer', '', '', '', '',
    'Parent', 'integer', 'NULL', '', '', '',
    'MessageId', 'varchar', 'NULL', '160', '', '',
    'Subject', 'varchar', 'NULL', '255', '', '',
    'Filename', 'varchar', 'NULL', '255', '', '',
    'ContentType', 'varchar', 'NULL', '80', '', '',
    'Content', 'blob', 'NULL', '', '', '',
    'Headers', 'blob', 'NULL', '', '', '',
    'Creator', 'integer', 'NULL', '', '', '',
    'Created', 'timestamp', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [  ],
  'index' => [  ],
},

'Templates' => {
  'columns' => [
    'id', 'serial', '', '', '', '',
    'Title', 'varchar', 'NULL', '120', '', '',
    'Language', 'varchar', 'NULL', '16', '', '',
    'TranslationOf', 'integer', 'NULL', '', '', '',
    'Content', 'blob', 'NULL', '', '', '',
    'LastUpdatedBy', 'integer', 'NULL', '', '', '',
    'LastUpdated', 'timestamp', 'NULL', '', '', '',
    'Creator', 'integer', 'NULL', '', '', '',
    'Created', 'timestamp', 'NULL', '', '', '',
  ],
  'primary_key' => 'id',
  'unique' => [  ],
  'index' => [  ],
}

};
